<?

class Logger {
	/* Usage :
	 * include('envolePHP/logger.php');
	 * $monlogger = new Logger("/var/log/monfichier.log");
	 * $monlogger->debug('msg');
	 * $monlogger->error('erreur')
	 */
	function Logger($file){
		// $file : fichier de log !! : droits d'écriture
		$this->file = $file;
	}
	public function debug($msg){
		// Fonction de debug
		if (is_array($msg)){
			$this->print_r($msg);
		}else{
			$msg = "DEBUG => " . $msg;
			$this->_write($msg);
		}
	}

	public function print_r($array){
		ob_start();
		print_r( $array );
		$output = ob_get_clean();
		$this->_write($output);
	}

	public function error($msg){
		// Loggue des erreurs
		$dbg = $this->_backtrace();
		$function = '?';
		$file = '?';
		$line = '?';
		if ( is_array($dbg) ) {
			for ( $i=1; $i<sizeof($dbg); $i++) {
				if ( is_array($dbg[$i]) ) {
					if ( $dbg[$i]['class'] == __CLASS__ ) {
						$function = $dbg[$i]['function'];
						$file = $dbg[$i]['file'];
						$line = $dbg[$i]['line'];
					}
				}
			}
		}
		$msgs =  "ERROR  - ".$msg." entités HTML : ".htmlentities($msg)." in : ".$file." on line :".$line;
		$this->_write($msgs);
	}
	private function _backtrace() {
		if ( function_exists('debug_backtrace') ) {
			return debug_backtrace();
		} else {
			return array();
		}
	}
	private function _getTime() {
		return  date('d-m-Y') . "  ". date('G') . ':' . date('i');
	}
	private function _write($msg){
		$msg = $this->_getTime() . "-" . $msg . "\n";
		file_put_contents($this->file, $msg, FILE_APPEND);
	}
}
?>
